/*
 * Dibujo.java
 *
 * Created on 9 de noviembre de 2004, 9:20
 */
import java.awt.*;
/**
 *
 * @author  Oscar
 *
 * Clase Dibujo, es la que crea el form
 * para realizar las simulaciones graficas 
 */
public class Dibujo extends javax.swing.JFrame{
    /** formulario padre*/
    public static simuredJava formu = null; 
    /**  idioma */
    public int idio;
    /** Hilo de simulacion */
    private Simular hilo = null;
    /** Creates new form Dibujo
     * @param idioma
     * @param form el formulario que lo ha creado 
     */
    public Dibujo(int idioma, simuredJava form) {
        idio = idioma;
        Dimension tam = new Dimension (500, 368); // tam predefinfo
        setPreferredSize(tam);
        formu = form;
        setLocation(10,10); // donde apareceera en pantalla
        setResizable(true); 
        setVisible(true);
        initComponents();
       form.AttachDibujo(AreaDibujo);
        pack();
         switch(idioma){
            case 1: // Spanish
                bGoOtro.setText("Simular");
                bPausa.setText("Pausa");
                bPaso.setText("Paso a Paso");
                bDetenerOtro.setText("Interrumpir");
                MostrarCheck.setText(" Mostrar Evolucion");
                VerNum.setText("Mostrar n. Flit");
                jLabel1.setText("  Retraso entre ciclos (ms)");
                jLabel2.setText("AREA DE SIMULACION");
                break;
            case 0: // English
                bGoOtro.setText("Simulate");
                bPausa.setText("Pause");
                bPaso.setText("Step simulate");
                bDetenerOtro.setText("Stop");
                MostrarCheck.setText("Show Evolution");
                VerNum.setText("Show Flit Number");
                jLabel1.setText("Cycle Delay (ms)");
                jLabel2.setText("SIMULATION AREA");
                break;
            default:;
         }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        AreaBotones = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        RetrasoTxt = new javax.swing.JComboBox();
        bDetenerOtro = new javax.swing.JButton();
        bPaso = new javax.swing.JButton();
        VerNum = new javax.swing.JCheckBox();
        MostrarCheck = new javax.swing.JCheckBox();
        bPausa = new javax.swing.JButton();
        bGoOtro = new javax.swing.JButton();
        AreaDibujo = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Simulacion");
        setName("Simulacion");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                ExitForm(evt);
            }
        });

        getAccessibleContext().setAccessibleParent(this);
        AreaBotones.setLayout(null);

        AreaBotones.setPreferredSize(new java.awt.Dimension(500, 80));
        jPanel1.setLayout(null);

        jPanel1.setBorder(new javax.swing.border.EtchedBorder());
        jLabel1.setFont(new java.awt.Font("Arial", 0, 11));
        jLabel1.setText("Retraso entre ciclos (ms)");
        jLabel1.setAutoscrolls(true);
        jPanel1.add(jLabel1);
        jLabel1.setBounds(360, 40, 140, 23);

        RetrasoTxt.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "0", "1", "100", "200", "500", "1000", "2000" }));
        jPanel1.add(RetrasoTxt);
        RetrasoTxt.setBounds(230, 40, 119, 23);

        bDetenerOtro.setText("Interrumpir");
        bDetenerOtro.setEnabled(false);
        bDetenerOtro.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bDetenerOtroActionPerformed(evt);
            }
        });

        jPanel1.add(bDetenerOtro);
        bDetenerOtro.setBounds(120, 40, 100, 25);

        bPaso.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 10));
        bPaso.setText("Paso a Paso");
        bPaso.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bPasoActionPerformed(evt);
            }
        });

        jPanel1.add(bPaso);
        bPaso.setBounds(10, 40, 100, 23);

        VerNum.setFont(new java.awt.Font("Arial", 0, 11));
        VerNum.setSelected(true);
        VerNum.setText("Mostrar n\u00ba Flit");
        VerNum.setAutoscrolls(true);
        VerNum.setEnabled(false);
        VerNum.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                VerNumActionPerformed(evt);
            }
        });

        jPanel1.add(VerNum);
        VerNum.setBounds(360, 10, 119, 22);

        MostrarCheck.setFont(new java.awt.Font("Arial", 0, 11));
        MostrarCheck.setText("Mostrar Evoluci\u00f3n");
        MostrarCheck.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MostrarCheckActionPerformed(evt);
            }
        });

        jPanel1.add(MostrarCheck);
        MostrarCheck.setBounds(230, 10, 119, 22);

        bPausa.setText("Pausa");
        bPausa.setEnabled(false);
        bPausa.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bPausaActionPerformed(evt);
            }
        });

        jPanel1.add(bPausa);
        bPausa.setBounds(120, 10, 100, 25);

        bGoOtro.setText("Simular");
        bGoOtro.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bGoOtroActionPerformed(evt);
            }
        });

        jPanel1.add(bGoOtro);
        bGoOtro.setBounds(10, 10, 100, 25);

        AreaBotones.add(jPanel1);
        jPanel1.setBounds(0, 0, 500, 80);

        getContentPane().add(AreaBotones, java.awt.BorderLayout.NORTH);

        AreaDibujo.setLayout(new java.awt.GridLayout(1, 0));

        jLabel2.setFont(new java.awt.Font("Arial Black", 0, 36));
        jLabel2.setForeground(new java.awt.Color(102, 153, 255));
        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel2.setText("AREA DE SIMULACION");
        AreaDibujo.add(jLabel2);

        getContentPane().add(AreaDibujo, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents
/** Simulacion paso a paso */
    private void bPasoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bPasoActionPerformed
        // TODO add your handling code here:
        formu.InteractCheck.setEnabled(false);
        MostrarCheck.setEnabled(false);
        bDetenerOtro.setEnabled(true);
        bPausa.setEnabled(true);
        if(idio == 1){
            bPausa.setText("Continuar");
        }
        else if(idio == 0){
            bPausa.setText("Continue");        
        }
        bGoOtro.setEnabled(false);
        if(formu.SimuStop == true){
            // Aqui solo debe entrar si no estaba simulando
            formu.Continuar = 1;
            formu.Interactiva = true;
            //hilo.setNotHecho();
            jLabel2.setText("");
            hilo = new Simular(formu, this);
            hilo.start();
            hilo.setNotHecho();
            hilo.setPaso();
 
        }
        else if(formu.Continuar == 1){
            hilo.setPaso();
            if(!hilo.getSleep())
                formu.Continuar = 2;       
        }
        else if((formu.Continuar == 1)&&(hilo.getSleep())){
            hilo.setPaso();
            hilo.HiloSim.Despierte();
            formu.Continuar = 2;
        }
        
    }//GEN-LAST:event_bPasoActionPerformed
/** Ver numero de paquete */
    private void VerNumActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_VerNumActionPerformed
        // TODO add your handling code here:
        if (VerNum.isSelected()){
            formu.vernum = 1;
        }
        else
            formu.vernum = 0;
    }//GEN-LAST:event_VerNumActionPerformed

    private void bDetenerOtroActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bDetenerOtroActionPerformed
        // TODO add your handling code here:
        formu.Continuar = 3;
        hilo.setHecho();
        
        bGoOtro.setEnabled(true);
        bDetenerOtro.setEnabled(false);
        bPausa.setEnabled(false);
        bPaso.setEnabled(MostrarCheck.isSelected());
        MostrarCheck.setEnabled(true);                 
    }//GEN-LAST:event_bDetenerOtroActionPerformed

    private void ExitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_ExitForm
        // TODO add your handling code here:
        formu.InteractCheck.setEnabled(true);
        formu.InteractCheck.setSelected(false);
        if (formu.SimuStop == false)
        
        if (formu.Continuar!= 0){
            if(idio == 1)
                formu.Muestra("Simulacion Cancelada");
            else
                formu.Muestra("Simulation Canceled");
        }
        
        formu.Continuar = 3;
        formu.SimuStop = true;
        if(hilo!= null)
            hilo.setHecho();
        setVisible(false);
        dispose();
        
    }//GEN-LAST:event_ExitForm

    private void MostrarCheckActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MostrarCheckActionPerformed
        // TODO add your handling code here:
        RetrasoTxt.setEnabled(MostrarCheck.isSelected());
        bPaso.setEnabled(MostrarCheck.isSelected());
        VerNum.setEnabled(MostrarCheck.isSelected());
    }//GEN-LAST:event_MostrarCheckActionPerformed

    private void bPausaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bPausaActionPerformed
        // TODO add your handling code here:
        if((bPausa.getText()=="Pausa")||(bPausa.getText()=="Pause")){
            if(idio == 1 )
                bPausa.setText("Continuar");
            else    
                bPausa.setText("Continue");
            hilo.setSleep();
        }
        else if(!hilo.getPaso()){
            
            hilo.HiloSim.Despierte();
            if(idio == 1 )
                bPausa.setText("Pausa");
            else    
                bPausa.setText("Pause");
           hilo.HiloSim.Despierte();
        }
        else if((hilo.getPaso()) && (hilo.getSleep())){
            hilo.setNotPaso();
            hilo.HiloSim.Despierte();
            if(idio == 1 )
                bPausa.setText("Pausa");
            else    
                bPausa.setText("Pause");
           hilo.HiloSim.Despierte();
        }
        else{
            hilo.setNotPaso();
            if(idio == 1 )
                bPausa.setText("Pausa");
            else    
                bPausa.setText("Pause");
        }
    }//GEN-LAST:event_bPausaActionPerformed

    private void bGoOtroActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bGoOtroActionPerformed
        // TODO add your handling code here:
        //Simular hilo;
        formu.Interactiva = true;
        formu.NoDibujes = false;
        jLabel2.setText("");
        MostrarCheck.setEnabled(false);
        bGoOtro.setEnabled(false);
        bDetenerOtro.setEnabled(true);
        
        if (MostrarCheck.isSelected()){
            formu.Continuar = 1;
            //SimuTimer.setEnabled(true);
            bPausa.setEnabled(true);
            bPaso.setEnabled(true);
           
        }
        else{
            formu.Continuar = 0;
            //SimuTimer.setEnabled(false);
            bPausa.setEnabled(false);
            bPaso.setEnabled(false);
        }
        /*formu.Simular();
          if(idio == 1)
            jLabel2.setText("SIMULACION COMPLETADA");
        else
            jLabel2.setText("SIMULATION COMPLETED");
        bGoOtro.setEnabled(true);
        bDetenerOtro.setEnabled(false);
        bPausa.setEnabled(false);
        bPaso.setEnabled(MostrarCheck.isSelected());
        MostrarCheck.setEnabled(true);            */
        hilo = new Simular(formu, this);
        hilo.start();        
    }//GEN-LAST:event_bGoOtroActionPerformed
    
       public void Idioma (int idioma){
        switch(idioma){
            case 1: // Spanish
                bGoOtro.setText("Simular");
                bPausa.setText("Pausa");
                bPaso.setText("Paso a Paso");
                bDetenerOtro.setText("Interrumpir");
                MostrarCheck.setText(" Mostrar Evolucion");
                VerNum.setText("Mostrar n. Flit");
                jLabel1.setText("Retraso entre ciclos (ms)");
                break;
            case 0: // English
                bGoOtro.setText("Simulate");
                bPausa.setText("Pause");
                bPaso.setText("Step simulate");
                bDetenerOtro.setText("Stop");
                MostrarCheck.setText("Show Evolution");
                VerNum.setText("Show Flit Number");
                jLabel1.setText("Cycle Delay (ms)");
                break;
            default:;
        }
    }     
   
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel AreaBotones;
    private javax.swing.JPanel AreaDibujo;
    public javax.swing.JCheckBox MostrarCheck;
    public javax.swing.JComboBox RetrasoTxt;
    public javax.swing.JCheckBox VerNum;
    public javax.swing.JButton bDetenerOtro;
    public javax.swing.JButton bGoOtro;
    public javax.swing.JButton bPaso;
    public javax.swing.JButton bPausa;
    public javax.swing.JLabel jLabel1;
    public javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
    
}
