/*
 * Graficas.java
 *
 * Created on 10 de abril de 2005, 12:53
 */
import java.util.*;
import java.lang.*;
import java.awt.*;
import java.lang.String.*;

/**
 *
 * @author  Oscar
 * Frame para mostrar las graficas
 */
public class Graficas extends javax.swing.JFrame {
    
    /** Creates new form Graficas */
    public Graficas() {
        initComponents();
        setVisible(true);
        setTitle("Graficas");
    }
    /**
     * Esta limitada a 5 lineas de datos, mas haya se muestran sin color 
     * ni leyenda 
     */
    public Graficas(simuredJava padre, ArrayList sims){
        float [] Param = new float[10]; 
        int cont = 0, simulaciones = 0;
        String titulo = new String();
         ArrayList bloque = (ArrayList)(sims.get(0));

        double [] valY = new double[bloque.size()];
        double [] valoresX = new double[bloque.size()] ;
        int indiX = padre.DevuelveEjeX();
        int indiY = padre.DevuelveEjeY();
         
            //padre.setInfo(padre.Xtxt.getItemAt(0).toString());  
            
            

            // Recorremos las simulaciones del bloque
            for (int j=0; j < bloque.size(); j++)
            {
                Vector sim = (Vector)(bloque.get(j));                
                valY[j] = (Float)(sim.get(indiY));
               valoresX[j] = (Float)(sim.get(indiX));
                Param[simulaciones] = (Float)sim.get(0); 
            } 
           titulo =  padre.Ytxt.getSelectedItem().toString() +" en funcion de "+padre.Xtxt.getSelectedItem().toString();
           // Nos creamos la grafica con la primera linea de datos
           Plot2D aPlot = new SimplePlotXY(valoresX, valY,"", padre.Xtxt.getSelectedItem().toString(),padre.Ytxt.getSelectedItem().toString(),
										null, null, new CircleSymbol());
            PlotAxis xAxis = aPlot.getHorizontalAxis();		
                xAxis.setScale(new LinearAxisScale());
                xAxis.setGridStyle(2);                 
                //padre.setCampo(1, Param[0]);
                simulaciones++;
      
                PlotRunList runs = aPlot.getRuns(); 
                // Cogemos la grafica actual y le anyadimos ls siguientes si existen 
                if(sims.size()>1)
                /*******************************************/
                for(int i=1; i < sims.size(); i++){            
            ArrayList bloques = (ArrayList)(sims.get(i));
            // recorremos las simulaciones del bloque
            double [] valYs = new double[bloques.size()];
            double [] valoresXs = new double[bloques.size()];
        
            
            for (int j=0; j < bloques.size(); j++)
            {       
                Vector sim = (Vector)(bloques.get(j));                
                valYs[j] = (Float)(sim.get(indiY));
               valoresXs[j] = (Float)(sim.get(indiX));
               Param[simulaciones] = (Float)sim.get(0); 
                
            } 
            simulaciones++;
           cont++; 
           
         
           if (cont == 1){
                PlotSymbol simbolo = new SquareSymbol();
                simbolo.setBorderColor(Color.blue);
                PlotRun pp = new PlotRun(valoresXs, valYs, true, simbolo);
                pp.setLineColor(Color.blue); 
                runs.add(pp);
                //padre.setCampo(2, Param[1]);
                
           }
           if (cont == 2){
                PlotSymbol simbolo = new DiamondSymbol();
                simbolo.setBorderColor(Color.red);
                PlotRun pp = new PlotRun(valoresXs, valYs, true, simbolo);
                pp.setLineColor(Color.red); 
                runs.add(pp);
                //padre.setCampo(3, Param[2]);
           }
           
           if (cont == 3){
                PlotSymbol simbolo = new RTriangle1Symbol();
                simbolo.setBorderColor(Color.green);
                PlotRun pp = new PlotRun(valoresXs, valYs, true, simbolo);
                pp.setLineColor(Color.green); 
                runs.add(pp);                
                //padre.setCampo(4, Param[3]);
           }
           if (cont== 4){
                PlotSymbol simbolo = new RTriangle2Symbol();
                simbolo.setBorderColor(Color.MAGENTA);
                PlotRun pp = new PlotRun(valoresXs, valYs, true, simbolo);
                pp.setLineColor(Color.MAGENTA); 
                runs.add(pp);
                //padre.setCampo(5, Param[4]);                
           }
           else if(cont > 4){
                runs.add(new PlotRun(valoresXs, valYs, true, new XSymbol()));
                //padre.setCampo(6, Param[cont]);               
           }
         }
         
        PlotPanel panel = new PlotPanel(aPlot);
		panel.setBackground( Color.white ); 
               
                getContentPane().add(panel);
                setSize(500, 300);
                setLocation(50,50);
                setTitle("Graficas");
                setVisible(true);
         
    }
   
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Graficas");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        jPanel1.setLayout(null);

        jLabel1.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 36));
        jLabel1.setForeground(new java.awt.Color(0, 0, 255));
        jLabel1.setText("Grafica");
        jPanel1.add(jLabel1);
        jLabel1.setBounds(160, 120, 116, 42);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel2, java.awt.BorderLayout.NORTH);

        pack();
    }//GEN-END:initComponents

    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        // TODO add your handling code here:
        dispose();        
    }//GEN-LAST:event_formWindowClosed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    // End of variables declaration//GEN-END:variables

}
